#include "constants.h"

const char *INSTRUCTION_NAMES[] = {
    [INST_NIL] = "NIL",
    [INST_T] = "T",
    [INST_STRING] = "STRING",
    [INST_INT] = "INT",
    [INST_FLOAT] = "FLOAT",
    [INST_CONS] = "CONS",
    [INST_LIST] = "LIST",
    [INST_VECTOR] = "VECTOR",
    [INST_LENGTH] = "LENGTH",
    [INST_INTERN_LIT] = "INTERN_LIT",
    [INST_INTERN_DYN] = "INTERN_DYN",
    [INST_TYPE_OF] = "TYPE_OF",
    [INST_SYMBOL_NAME] = "SYMBOL_NAME",
    [INST_MOV] = "MOV",
    [INST_FUNCALL] = "FUNCALL",
    [INST_RETVAL_COUNT] = "RETVAL_COUNT",
    [INST_GET_RETVAL_COUNT] = "GET_RETVAL_COUNT",
    [INST_ENTER_LEXENV] = "ENTER_LEXENV",
    [INST_ENTER_BLOCK] = "ENTER_BLOCK",
    [INST_LEAVE_BLOCK] = "LEAVE_BLOCK",
    [INST_SET_VALUE] = "SET_VALUE",
    [INST_SET_FUNCTION] = "SET_FUNCTION",
    [INST_GET_VALUE] = "GET_VALUE",
    [INST_GET_FUNCTION] = "GET_FUNCTION",
    [INST_BOUNDP] = "BOUNDP",
    [INST_FUNCTIONP] = "FUNCTIONP",
    [INST_NEWFUNCTION_LIT] = "NEWFUNCTION_LIT",
    [INST_NEWFUNCTION_DYN] = "NEWFUNCTION_DYN",
    [INST_PUT] = "PUT",
    [INST_GET] = "GET",
    [INST_AND] = "AND",
    [INST_ANDN] = "ANDN",
    [INST_OR] = "OR",
    [INST_ORN] = "ORN",
    [INST_XOR] = "XOR",
    [INST_XORN] = "XORN",
    [INST_NOT] = "NOT",
    [INST_JMP] = "JMP",
    [INST_CJMP] = "CJMP",
    [INST_CAR] = "CAR",
    [INST_CDR] = "CDR",
    [INST_SETCAR] = "SETCAR",
    [INST_SETCDR] = "SETCDR",
    [INST_GETELT_LIT] = "GETELT_LIT",
    [INST_GETELT_DYN] = "GETELT_DYN",
    [INST_SETELT_LIT] = "SETELT_LIT",
    [INST_SETELT_DYN] = "SETELT_DYN",
    [INST_EQ] = "EQ",
    [INST_NUM_GT] = "NUM_GT",
    [INST_NUM_GE] = "NUM_GE",
    [INST_NUM_EQ] = "NUM_EQ",
    [INST_NUM_LE] = "NUM_LE",
    [INST_NUM_LT] = "NUM_LT",
    [INST_ADD] = "ADD",
    [INST_ADDN] = "ADDN",
    [INST_SUB] = "SUB",
    [INST_SUBN] = "SUBN",
    [INST_MUL] = "MUL",
    [INST_MULN] = "MULN",
    [INST_DIV] = "DIV",
    [INST_INT_DIV] = "INT_DIV",
    [INST_RECIP] = "RECIP",
    [INST_MOD] = "MOD",
    [INST_SQRT] = "SQRT",
    [INST_POW] = "POW",
    [INST_LN] = "LN",
    [INST_EXP] = "EXP",
    [INST_SIN] = "SIN",
    [INST_COS] = "COS",
    [INST_TAN] = "TAN",
    [INST_ASIN] = "ASIN",
    [INST_ACOS] = "ACOS",
    [INST_ATAN] = "ATAN",
    [INST_BITAND] = "BITAND",
    [INST_BITOR] = "BITOR",
    [INST_BITXOR] = "BITXOR",
    [INST_BITNOR] = "BITNOR",
    [INST_BITNEG] = "BITNEG",
    [INST_LSH] = "LSH",
    [INST_ASH] = "ASH",
};

const char *REGISTER_NAMES[] = {
    [REG_VAL] = "val",
    [REG_SAVED] = "saved",
    [REG_ARG] = "arg",
    [REG_RET] = "ret",
};
